#ifndef _TSXREADER_
#define _TSXREADER_

#include <apertium/TTag.H>
#include <lttoolbox/Recognizer.H>

#include <libxml/xmlreader.h>
#include <map>
#include <set>
#include <string>
#include <vector>

using namespace std;

class TSXReader
{
private:
  xmlTextReaderPtr reader;  
  set<TTag> open_class;
  vector<TForbidRule> forbid_rules;
  map<string, TTag> tag_index;
  vector<string> array_tags;
  vector<TEnforceAfterRule> enforce_rules;
  map<string, Recognizer> recognizer;

  int type;
  string name;

  string attrib(string const &name);
  string latin1(xmlChar const *input);

  void parseError(string const &message);
  void newTagIndex(string const &tag);
  void procDefLabel();
  void procDefMult();
  void procTagset();
  void procForbid();
  void procLabelSequence();
  void procEnforce();
  void procPreferences();
  void copy(TSXReader const &o);
  void destroy();

  void step();
public:
  TSXReader();
  ~TSXReader();
  TSXReader(TSXReader const &o);
  TSXReader & operator =(TSXReader const &o);

  void read(string const &filename);
};

#endif
